#include<scl1.h>

/*                       SCL1.LIB's Background Function Demo

	To run this demo inside QuickC environment:

		Copy SCL1.H into your INCLUDE subdirectory.
		Load SCL1 Quick Library.
		Turn Screen Swapping On (QC's Debug Menu).
		Compile it (memory output option)

	NOTE: Trying to step through this program will likely crash your
		  system.

		To Load SCL1 Quick Library:

			qc /l scl1

	File SCL1.QLB must be located in the path specified in the LIB
	environment variable directory or in your default drive/path

	*/

/* Background function declaration */

int backf(void);

char Buffer1[20];
char Buffer2[20];

unsigned int i;

char Color1=BLUE_BLACK+HIGHLIGHT,Color2=RED_BLACK+HIGHLIGHT,Color3=BROWN_BLACK+HIGHLIGHT;

main()
{
unsigned int seconds=0;

/* Initialize video & turn cursor off */

InitVideo();
CursorOff();

/* Change colors to B&W in case of a mono monitor */

if(Video()==MONO)
	Color1=Color2=Color3=BLACK_WHITE;

/* Prepare screen */

WriteScreen(Color1,6,10,"Press any key to turn Background function on...");

/* Wait for a key to turn Background function on */

WaitKeyMouse();
Cls(7,CLS_ALL);
WriteScreen(Color1,12,10,"Press any key to stop Background function...");
WriteScreen(Color2,8,10,"MAIN PROGRAM: Background function has been active for 0 seconds.");
WriteScreen(Color3,10,10,"BACKGROUND FUNCTION: Times I've been called: ");

/* Turn Background function ON */

BackgroundOn(backf);

/* Loop until a key is pressed */

do
	{
	WaitTime(100);                          /* Count seconds */
	++seconds;
	sprintf(Buffer1,"%d seconds.",seconds);
	WriteScreen(Color2,8,64,Buffer1);       /* Write elapsed time */
	}while(!KeyReady());

/* Turn background function OFF */

BackgroundOff();

/* Exit */

ClearKeyBuf();
CursorOn();
SetCurPos(20,0);
}


/* Sample Background function. This function will be called 18.2 per second.
   It writes the number of times it has been called and returns control as
   soon as possible. Since it will operate with the system stack we'll use
   the pragma "check_stack(off)" to tell the compiler not to check for
   stack overflow when entering this function */

#pragma check_stack(off)

int backf(void)
{
++i;
WriteScreen(Color3,10,55,Bin2Ascii((long)i,Buffer2));
}
